/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.data;


import android.app.SearchManager;
import android.content.ContentProvider;
import android.content.ContentUris;
import android.content.ContentValues;
import android.content.Intent;
import android.content.UriMatcher;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.net.Uri;
import android.text.TextUtils;
import android.util.Log;

import net.micode.notes.R;
import net.micode.notes.data.Notes.DataColumns;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.data.NotesDatabaseHelper.TABLE;

/*
* 功能描述：用于提供对便签数据的存储和获取功能，实现了创建、读取、更新、删除操作，以便其他组件可以通过 ContentResolver 访问和管理便签数据。
* */
public class NotesProvider extends ContentProvider {
    private static final UriMatcher mMatcher;// UriMatcher用于匹配Uri

    private NotesDatabaseHelper mHelper;// 数据库帮助类

    private static final String TAG = "NotesProvider";// 标签

    private static final int URI_NOTE            = 1;// Uri匹配码
    private static final int URI_NOTE_ITEM       = 2;
    private static final int URI_DATA            = 3;
    private static final int URI_DATA_ITEM       = 4;

    private static final int URI_SEARCH          = 5;
    private static final int URI_SEARCH_SUGGEST  = 6;

    static {
        mMatcher = new UriMatcher(UriMatcher.NO_MATCH);// 创建UriMatcher时，调用UriMatcher(UriMatcher.NO_MATCH)表示不匹配任何路径的返回码
        /*
        * 把需要匹配Uri路径全部给注册上
        * */
        mMatcher.addURI(Notes.AUTHORITY, "note", URI_NOTE);// 便签列表的路径
        mMatcher.addURI(Notes.AUTHORITY, "note/#", URI_NOTE_ITEM);// 便签详情的路径，其中 "#" 表示数字，表示具体的便签 ID
        mMatcher.addURI(Notes.AUTHORITY, "data", URI_DATA);// 数据列表的路径
        mMatcher.addURI(Notes.AUTHORITY, "data/#", URI_DATA_ITEM);// 数据详情的路径，其中 "#" 表示数字，表示具体的数据 ID
        mMatcher.addURI(Notes.AUTHORITY, "search", URI_SEARCH);// 搜索的路径
        mMatcher.addURI(Notes.AUTHORITY, SearchManager.SUGGEST_URI_PATH_QUERY, URI_SEARCH_SUGGEST);// 搜索建议的路径
        mMatcher.addURI(Notes.AUTHORITY, SearchManager.SUGGEST_URI_PATH_QUERY + "/*", URI_SEARCH_SUGGEST);// 带搜索关键字的搜索建议的路径
    }

    /**
     * x'0A' represents the '\n' character in sqlite. For title and content in the search result,
     * we will trim '\n' and white space in order to show more information.
     */

    /*
    * 查询搜索结果的投影。该投影包含了搜索结果需要的各个字段，如便签的 ID、搜索文本等
    * */
    private static final String NOTES_SEARCH_PROJECTION = NoteColumns.ID + ","
        + NoteColumns.ID + " AS " + SearchManager.SUGGEST_COLUMN_INTENT_EXTRA_DATA + ","
        + "TRIM(REPLACE(" + NoteColumns.SNIPPET + ", x'0A','')) AS " + SearchManager.SUGGEST_COLUMN_TEXT_1 + ","
        + "TRIM(REPLACE(" + NoteColumns.SNIPPET + ", x'0A','')) AS " + SearchManager.SUGGEST_COLUMN_TEXT_2 + ","
        + R.drawable.search_result + " AS " + SearchManager.SUGGEST_COLUMN_ICON_1 + ","
        + "'" + Intent.ACTION_VIEW + "' AS " + SearchManager.SUGGEST_COLUMN_INTENT_ACTION + ","
        + "'" + Notes.TextNote.CONTENT_TYPE + "' AS " + SearchManager.SUGGEST_COLUMN_INTENT_DATA;

    /*
    * 查询语句，用于查询搜索结果
    * */
    private static String NOTES_SNIPPET_SEARCH_QUERY = "SELECT " + NOTES_SEARCH_PROJECTION
        + " FROM " + TABLE.NOTE
        + " WHERE " + NoteColumns.SNIPPET + " LIKE ?"
        + " AND " + NoteColumns.PARENT_ID + "<>" + Notes.ID_TRASH_FOLER
        + " AND " + NoteColumns.TYPE + "=" + Notes.TYPE_NOTE;

    @Override
    /*
    *在onCreate()中初始化Context，实例化mHelper
    * */
    public boolean onCreate() {
        mHelper = NotesDatabaseHelper.getInstance(getContext());
        return true;
    }

    @Override
    /*
    * 根据传入的Uri进行数据库查询操作
    * */
    public Cursor query(Uri uri, String[] projection, String selection, String[] selectionArgs,
            String sortOrder) {
        Cursor c = null;// 定义一个Cursor对象用于存放查询结果
        SQLiteDatabase db = mHelper.getReadableDatabase();// 获取可读数据库实例
        String id = null;// 用于存放ID值
        /*
        * 根据Uri使用Matcher匹配相应的操作，对于不同的匹配值，在数据库中查找相应的条目
        * */
        switch (mMatcher.match(uri)) {
            case URI_NOTE:
                c = db.query(TABLE.NOTE, projection, selection, selectionArgs, null, null,
                        sortOrder);// 查询便签列表
                break;
            case URI_NOTE_ITEM:
                id = uri.getPathSegments().get(1);// 获取Uri中的ID值
                c = db.query(TABLE.NOTE, projection, NoteColumns.ID + "=" + id
                        + parseSelection(selection), selectionArgs, null, null, sortOrder);// 查询特定ID的便签详情
                break;
            case URI_DATA:
                c = db.query(TABLE.DATA, projection, selection, selectionArgs, null, null,
                        sortOrder);// 查询数据列表
                break;
            case URI_DATA_ITEM:
                id = uri.getPathSegments().get(1); // 获取Uri中的ID值
                c = db.query(TABLE.DATA, projection, DataColumns.ID + "=" + id
                        + parseSelection(selection), selectionArgs, null, null, sortOrder);// 查询特定ID的数据详情
                break;
            case URI_SEARCH:
            case URI_SEARCH_SUGGEST:
                if (sortOrder != null || projection != null) {
                    throw new IllegalArgumentException(
                            "do not specify sortOrder, selection, selectionArgs, or projection" + "with this query");// 如果存在不合法的参数则抛出异常
                }

                String searchString = null;
                if (mMatcher.match(uri) == URI_SEARCH_SUGGEST) {
                    if (uri.getPathSegments().size() > 1) {
                        searchString = uri.getPathSegments().get(1); // 获取搜索关键字
                    }
                } else {
                    searchString = uri.getQueryParameter("pattern"); // 获取搜索关键字
                }

                if (TextUtils.isEmpty(searchString)) {
                    return null;// 如果搜索关键字为空则直接返回null
                }

                try {
                    searchString = String.format("%%%s%%", searchString);// 格式化搜索关键字
                    c = db.rawQuery(NOTES_SNIPPET_SEARCH_QUERY,
                            new String[] { searchString });// 执行搜索查询
                } catch (IllegalStateException ex) {
                    Log.e(TAG, "got exception: " + ex.toString());// 捕获异常
                }
                break;
            default:
                throw new IllegalArgumentException("Unknown URI " + uri);// 对于未知的Uri抛出异常
        }
        if (c != null) {
            c.setNotificationUri(getContext().getContentResolver(), uri);// 设置查询结果的变更通知URI
        }
        return c;// 返回查询结果的Cursor对象
    }

    @Override
    /*
    * 功能描述：实现对数据库表单的增加记录操作
    * 输入参数：参数 uri 表示插入的 URI，values 表示插入的值
    * */
    public Uri insert(Uri uri, ContentValues values) {
        SQLiteDatabase db = mHelper.getWritableDatabase();// 获得可写的数据库
        long dataId = 0, noteId = 0, insertedId = 0;// 定义三个id值变量
        /*
        * 根据Uri使用Matcher匹配相应的操作
        * */
        switch (mMatcher.match(uri)) {
            case URI_NOTE:
                insertedId = noteId = db.insert(TABLE.NOTE, null, values);// 在便签表中插入新记录
                break;
            case URI_DATA:
                if (values.containsKey(DataColumns.NOTE_ID)) {
                    noteId = values.getAsLong(DataColumns.NOTE_ID);// 如果数据内容包含NOTE_ID字段，获取NOTE_ID值
                } else {
                    Log.d(TAG, "Wrong data format without note id:" + values.toString());// 如果不包含则输出日志信息
                }
                insertedId = dataId = db.insert(TABLE.DATA, null, values);// 在数据表中插入新记录
                break;
            default:
                throw new IllegalArgumentException("Unknown URI " + uri);// 对于未知的Uri抛出异常
        }
        // Notify the note uri
        if (noteId > 0) {// 如果是便签新增操作
            getContext().getContentResolver().notifyChange(
                    ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, noteId), null);// 通过ContentResolver对象发送通知，更新便签的变更通知URI
        }

        // Notify the data uri
        if (dataId > 0) {// 如果是数据新增操作
            getContext().getContentResolver().notifyChange(
                    ContentUris.withAppendedId(Notes.CONTENT_DATA_URI, dataId), null);// 通过ContentResolver对象发送通知，更新数据的变更通知URI
        }

        return ContentUris.withAppendedId(uri, insertedId);// 返回插入的uri的路径
    }

    @Override
    /*
    * 功能描述：实现对数据库表单的删除记录操作
    * 输入参数：参数 uri 表示删除的 URI，selection 表示删除条件，selectionArgs 表示删除条件值
    * */
    public int delete(Uri uri, String selection, String[] selectionArgs) {
        //Uri代表要操作的数据，Android上可用的每种资源 -包括 图像、视频片段、音频资源等都可以用Uri来表示
        int count = 0;// 定义计数变量
        String id = null;// 定义id字符串变量
        SQLiteDatabase db = mHelper.getWritableDatabase();// 获取可写数据库实例
        boolean deleteData = false;// 是否删除数据标志位
        /*
        * 根据Uri使用Matcher匹配相应的操作
        * */
        switch (mMatcher.match(uri)) {
            case URI_NOTE:
                selection = "(" + selection + ") AND " + NoteColumns.ID + ">0 ";// 对于便签的删除操作，添加额外的条件限制
                count = db.delete(TABLE.NOTE, selection, selectionArgs);// 在便签表中删除符合条件的记录
                break;
            case URI_NOTE_ITEM:
                id = uri.getPathSegments().get(1);// 获取Uri中的ID参数
                /**
                 * ID that smaller than 0 is system folder which is not allowed to
                 * trash
                 */
                long noteId = Long.valueOf(id);
                if (noteId <= 0) {// 如果ID小于等于0，则不允许删除
                    break;
                }
                count = db.delete(TABLE.NOTE,
                        NoteColumns.ID + "=" + id + parseSelection(selection), selectionArgs);// 在便签表中删除指定ID的记录
                break;
            case URI_DATA:
                count = db.delete(TABLE.DATA, selection, selectionArgs);// 在数据表中删除符合条件的记录
                deleteData = true;// 设置删除数据标志位为true
                break;
            case URI_DATA_ITEM:
                id = uri.getPathSegments().get(1);// 获取Uri中的ID参数
                count = db.delete(TABLE.DATA,
                        DataColumns.ID + "=" + id + parseSelection(selection), selectionArgs);// 在数据表中删除指定ID的记录
                deleteData = true;// 设置删除数据标志位为true
                break;
            default:
                throw new IllegalArgumentException("Unknown URI " + uri);// 对于未知的Uri抛出异常
        }
        if (count > 0) {// 如果删除记录数大于0
            if (deleteData) {
                getContext().getContentResolver().notifyChange(Notes.CONTENT_NOTE_URI, null);// 通过ContentResolver对象发送通知，更新便签变更通知URI
            }
            getContext().getContentResolver().notifyChange(uri, null);// 通过ContentResolver对象发送通知，更新变更通知URI
        }
        return count;// 返回删除的记录数
    }

    @Override
    /*
    * 功能描述：实现对数据库表单的更新操作
    * 输入参数：参数 uri 表示更新的 URI，values 表示更新的值，selection 表示更新条件，selectionArgs 表示更新条件值
    * */
    public int update(Uri uri, ContentValues values, String selection, String[] selectionArgs) {
        int count = 0;// 定义计数变量
        String id = null;// 定义id字符串变量
        SQLiteDatabase db = mHelper.getWritableDatabase();// 获取可写数据库实例
        boolean updateData = false;// 是否更新数据标志位
        /*
        * 根据Uri使用Matcher匹配相应的操作
        * */
        switch (mMatcher.match(uri)) {
            case URI_NOTE:
                increaseNoteVersion(-1, selection, selectionArgs);// 增加便签版本号，针对便签的更新操作，添加额外的条件限制
                count = db.update(TABLE.NOTE, values, selection, selectionArgs);// 在便签表中更新符合条件的记录
                break;
            case URI_NOTE_ITEM:
                id = uri.getPathSegments().get(1);// 获取Uri中的ID参数
                increaseNoteVersion(Long.valueOf(id), selection, selectionArgs);// 增加便签版本号，针对便签的更新操作，添加额外的条件限制
                count = db.update(TABLE.NOTE, values, NoteColumns.ID + "=" + id
                        + parseSelection(selection), selectionArgs);// 在便签表中更新指定ID的记录
                break;
            case URI_DATA:
                count = db.update(TABLE.DATA, values, selection, selectionArgs);// 在数据表中更新符合条件的记录
                updateData = true;// 设置更新数据标志位为tru
                break;
            case URI_DATA_ITEM:
                id = uri.getPathSegments().get(1);// 获取Uri中的ID参数
                count = db.update(TABLE.DATA, values, DataColumns.ID + "=" + id
                        + parseSelection(selection), selectionArgs);// 在数据表中更新指定ID的记录
                updateData = true;// 设置更新数据标志位为true
                break;
            default:
                throw new IllegalArgumentException("Unknown URI " + uri);// 对于未知的Uri抛出异常
        }

        if (count > 0) {// 如果更新记录数大于0
            if (updateData) {
                getContext().getContentResolver().notifyChange(Notes.CONTENT_NOTE_URI, null);// 通过ContentResolver对象发送通知，更新便签变更通知URI
            }
            getContext().getContentResolver().notifyChange(uri, null);// 通过ContentResolver对象发送通知，更新变更通知URI
        }
        return count;// 返回更新的记录数
    }

    /*
    * 解析查询条件selection，如果selection不为空，则在其前面加上" AND "，用于拼接SQL语句
    * */
    private String parseSelection(String selection) {
        return (!TextUtils.isEmpty(selection) ? " AND (" + selection + ')' : "");
    }

    /*
    * 根据传入的id和selection参数确定要更新的记录，并将版本号加1
    * */
    private void increaseNoteVersion(long id, String selection, String[] selectionArgs) {
        StringBuilder sql = new StringBuilder(120);// 创建一个StringBuilder对象，用于构建SQL语句
        sql.append("UPDATE ");// 构建UPDATE语句，指定要更新的表名
        sql.append(TABLE.NOTE);// 表名
        sql.append(" SET ");// 指定要更新的字段和新的值
        sql.append(NoteColumns.VERSION);// 字段名
        sql.append("=" + NoteColumns.VERSION + "+1 ");// 将版本号加1

        if (id > 0 || !TextUtils.isEmpty(selection)) {
            sql.append(" WHERE ");// 根据传入的参数决定是否添加WHERE子句
        }
        if (id > 0) {
            sql.append(NoteColumns.ID + "=" + String.valueOf(id)); // 如果传入的id大于0，则表示只更新指定id的记录
        }
        if (!TextUtils.isEmpty(selection)) {// 如果传入的selection不为空，则根据它来确定要更新的记录
            String selectString = id > 0 ? parseSelection(selection) : selection;// 调用parseSelection方法将selection转换为SQL语句中的WHERE子句
            for (String args : selectionArgs) {
                selectString = selectString.replaceFirst("\\?", args);// 替换WHERE子句中的问号占位符为实际的参数值
            }
            sql.append(selectString);// 添加WHERE子句到SQL语句中
        }

        // execSQL()方法可以执行insert、delete、update和CREATE TABLE之类有更改行为的SQL语句
        mHelper.getWritableDatabase().execSQL(sql.toString());// 添加WHERE子句到SQL语句中
    }

    @Override
    /*
    * 功能描述：用于根据 URI 返回相应的 MIME 类型
    * 输入参数：参数 uri 表示查询或操作的 URI
    * 函数中是环境自动生成的，也可自己改写
    * */
    public String getType(Uri uri) {
        // TODO Auto-generated method stub
        return null;
    }
}
